commit 8a825bb497d8801c39fafec0005c11f13da631ea
Author: freddy77 <freddy77>
Date:   Wed Aug 6 07:40:10 2008 +0000

    keep packet size to safe values

diff --git a/ChangeLog b/ChangeLog
index 1bef97c..7e437fa 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Wed Aug 06 09:32:32 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/config.c src/tds/login.c src/tds/mem.c src/tds/token.c:
+	- keep packet size to safe values
+
 Thu Jul 31 16:53:35 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/challenge.c: removed important FIXMEs
 
@@ -504,4 +508,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2574 2008/07/31 14:57:01 freddy77 Exp $
+$Id: ChangeLog,v 1.2575 2008/08/06 07:40:10 freddy77 Exp $
diff --git a/src/tds/config.c b/src/tds/config.c
index 9be062a..b70310c 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.133 2008/01/18 13:37:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.134 2008/08/06 07:40:15 freddy77 Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -495,8 +495,9 @@ tds_parse_conf_section(const char *option, const char *value, void *param)
 	if (!strcmp(option, TDS_STR_VERSION)) {
 		tds_config_verstr(value, connection);
 	} else if (!strcmp(option, TDS_STR_BLKSZ)) {
-		if (atoi(value))
-			connection->block_size = atoi(value);
+		int val = atoi(value);
+		if (val >= 512 && val < 65536)
+			connection->block_size = val;
 	} else if (!strcmp(option, TDS_STR_SWAPDT)) {
 		connection->broken_dates = tds_config_boolean(value);
 	} else if (!strcmp(option, TDS_STR_SWAPMNY)) {
diff --git a/src/tds/login.c b/src/tds/login.c
index 6fe7f1c..bf22c20 100644
--- a/src/tds/login.c
+++ b/src/tds/login.c
@@ -51,7 +51,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: login.c,v 1.174 2008/07/11 09:25:56 freddy77 Exp $");
+TDS_RCSID(var, "$Id: login.c,v 1.175 2008/08/06 07:40:16 freddy77 Exp $");
 
 static int tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 static int tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection);
@@ -628,7 +628,7 @@ tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	tds_put_byte(tds, 1);
 
 	/* network packet size */
-	if (connection->block_size < 1000000 && connection->block_size)
+	if (connection->block_size < 65536 && connection->block_size > 0)
 		sprintf(blockstr, "%d", connection->block_size);
 	else
 		strcpy(blockstr, "512");
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 35953b2..14ec4f9 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -47,7 +47,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.176 2008/05/26 13:56:50 freddy77 Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.177 2008/08/06 07:40:17 freddy77 Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -991,7 +991,8 @@ tds_realloc_socket(TDSSOCKET * tds, int bufsize)
 	if (tds->env.block_size == bufsize)
 		return tds;
 
-	if ((new_out_buf = (unsigned char *) realloc(tds->out_buf, bufsize + TDS_ADDITIONAL_SPACE)) != NULL) {
+	if (tds->out_pos <= bufsize && bufsize > 0 && 
+	    (new_out_buf = (unsigned char *) realloc(tds->out_buf, bufsize + TDS_ADDITIONAL_SPACE)) != NULL) {
 		tds->out_buf = new_out_buf;
 		tds->env.block_size = bufsize;
 		return tds;
diff --git a/src/tds/token.c b/src/tds/token.c
index 07717c8..e91c316 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.349 2008/07/15 15:20:54 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.350 2008/08/06 07:40:17 freddy77 Exp $");
 
 static int tds_process_msg(TDSSOCKET * tds, int marker);
 static int tds_process_compute_result(TDSSOCKET * tds);
@@ -2408,14 +2408,13 @@ tds_process_env_chg(TDSSOCKET * tds)
 	switch (type) {
 	case TDS_ENV_PACKSIZE:
 		new_block_size = atoi(newval);
-		if (new_block_size > tds->env.block_size) {
-			tdsdump_log(TDS_DBG_INFO1, "increasing block size from %s to %d\n", oldval, new_block_size);
+		if (new_block_size >= 512) {
+			tdsdump_log(TDS_DBG_INFO1, "changing block size from %s to %d\n", oldval, new_block_size);
 			/* 
-			 * I'm not aware of any way to shrink the 
-			 * block size but if it is possible, we don't 
-			 * handle it.
+			 * Is possible to have a shrink if server limits packet
+			 * size more than what we specified
 			 */
-			/* Reallocate buffer if impossible (strange values from server or out of memory) use older buffer */
+			/* Reallocate buffer if possible (strange values from server or out of memory) use older buffer */
 			tds_realloc_socket(tds, new_block_size);
 		}
 		break;

